package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 生产过程上下文对象-设备LOG采集处理对象
 */
@Data
public class MesEquipLogDispatchContext implements Serializable {

    private static final long serialVersionUID = 917933189935264321L;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("是否采集到数据")
    private Boolean isCollectValue = false;

    @ApiParam("是否常变值")
    private Boolean needNewValue = false;

    @ApiParam("数据变量接口逻辑信息集合")
    private List<MesEquipVariableCfgCollectContext> equipVariableCfgCollectContextList;

    @ApiParam("需要重置设备LOG表ID集合")
    private List<Long> resetEquipmentLogIdList;

    public MesEquipLogDispatchContext() {}

    public MesEquipLogDispatchContext(String organizeCode) {
        this.organizeCode = organizeCode;
    }

    public MesEquipLogDispatchContext isCollectValue() {
        this.isCollectValue = true;
        return this;
    }

    public MesEquipLogDispatchContext needNewValue() {
        this.needNewValue = true;
        return this;
    }

    public MesEquipLogDispatchContext equipVariableCfgCollectContextList(List<MesEquipVariableCfgCollectContext> equipVariableCfgCollectContextList) {
        this.equipVariableCfgCollectContextList = equipVariableCfgCollectContextList;
        return this;
    }

    public MesEquipLogDispatchContext resetEquipmentLogIdList(List<Long> equipmentLogIdList) {
        if (CollectionUtils.isEmpty(equipmentLogIdList)) return this;
        if (CollectionUtils.isEmpty(this.resetEquipmentLogIdList)) this.resetEquipmentLogIdList = new ArrayList<>();
        this.resetEquipmentLogIdList.addAll(equipmentLogIdList);
        this.resetEquipmentLogIdList = CollectionUtils.isEmpty(this.resetEquipmentLogIdList) ? null : this.resetEquipmentLogIdList.stream().filter(o -> !StringUtils.isEmpty(o)).distinct().collect(Collectors.toList());
        return this;
    }

}
